package dev.shadowsoffire.apotheosis.adventure.boss;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.AdventureConfig;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.apotheosis.adventure.boss.ApothBoss;
import dev.shadowsoffire.apotheosis.adventure.boss.ApothMiniboss;
import dev.shadowsoffire.apotheosis.adventure.boss.BossRegistry;
import dev.shadowsoffire.apotheosis.adventure.boss.MinibossRegistry;
import dev.shadowsoffire.apotheosis.adventure.client.BossSpawnMessage;
import dev.shadowsoffire.apotheosis.adventure.compat.GameStagesCompat;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import dev.shadowsoffire.placebo.network.PacketDistro;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;
import it.unimi.dsi.fastutil.objects.Object2IntMap;
import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
import java.util.function.Predicate;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TextColor;
import net.minecraft.network.protocol.Packet;
import net.minecraft.network.protocol.game.ClientboundSetActionBarTextPacket;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.util.RandomSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.entity.MobSpawnType;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.ServerLevelAccessor;
import net.minecraft.world.phys.Vec3;
import net.minecraftforge.event.TickEvent;
import net.minecraftforge.event.entity.EntityJoinLevelEvent;
import net.minecraftforge.event.entity.living.MobSpawnEvent;
import net.minecraftforge.event.server.ServerStartedEvent;
import net.minecraftforge.eventbus.api.Event;
import net.minecraftforge.eventbus.api.EventPriority;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import org.apache.commons.lang3.tuple.Pair;

public class BossEvents {
  public Object2IntMap<ResourceLocation> bossCooldowns = (Object2IntMap<ResourceLocation>)new Object2IntOpenHashMap();
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void naturalBosses(MobSpawnEvent.FinalizeSpawn e) {
    if (e.getSpawnType() == MobSpawnType.NATURAL || e.getSpawnType() == MobSpawnType.CHUNK_GENERATION) {
      Mob mob = e.getEntity();
      RandomSource rand = e.getLevel().m_213780_();
      if (this.bossCooldowns.getInt(mob.m_9236_().m_46472_().m_135782_()) <= 0 && !e.getLevel().m_5776_() && mob instanceof net.minecraft.world.entity.monster.Monster && e.getResult() != Event.Result.DENY) {
        ServerLevelAccessor sLevel = e.getLevel();
        ResourceLocation dimId = sLevel.m_6018_().m_46472_().m_135782_();
        Pair<Float, BossSpawnRules> rules = (Pair<Float, BossSpawnRules>)AdventureConfig.BOSS_SPAWN_RULES.get(dimId);
        if (rules == null)
          return; 
        if (rand.m_188501_() <= ((Float)rules.getLeft()).floatValue() && ((BossSpawnRules)rules.getRight()).test(sLevel, BlockPos.m_274561_(e.getX(), e.getY(), e.getZ()))) {
          Player player = sLevel.m_45924_(e.getX(), e.getY(), e.getZ(), -1.0D, false);
          if (player == null)
            return; 
          ApothBoss item = (ApothBoss)BossRegistry.INSTANCE.getRandomItem(rand, player.m_36336_(), new Predicate[] { WeightedDynamicRegistry.IDimensional.matches((Level)sLevel.m_6018_()), GameStagesCompat.IStaged.matches(player) });
          if (item == null) {
            AdventureModule.LOGGER.error("Attempted to spawn a boss in dimension {} using configured boss spawn rule {}/{} but no bosses were made available.", dimId, rules.getRight(), rules.getLeft());
            return;
          } 
          Mob boss = item.createBoss(sLevel, BlockPos.m_274561_(e.getX() - 0.5D, e.getY(), e.getZ() - 0.5D), rand, player.m_36336_());
          if (AdventureConfig.bossAutoAggro && !player.m_7500_())
            boss.m_6710_((LivingEntity)player); 
          if (canSpawn((LevelAccessor)sLevel, boss, player.m_20280_((Entity)boss))) {
            sLevel.m_47205_((Entity)boss);
            e.setResult(Event.Result.DENY);
            AdventureModule.debugLog(boss.m_20183_(), "Surface Boss - " + boss.m_7755_().getString());
            Component name = getName(boss);
            if (name == null || name.m_7383_().m_131135_() == null) {
              AdventureModule.LOGGER.warn("A Boss {} ({}) has spawned without a custom name!", boss.m_7755_().getString(), EntityType.m_20613_(boss.m_6095_()));
            } else {
              sLevel.m_6907_().forEach(p -> {
                    Vec3 tPos = new Vec3(boss.m_20185_(), AdventureConfig.bossAnnounceIgnoreY ? p.m_20186_() : boss.m_20186_(), boss.m_20189_());
                    if (p.m_20238_(tPos) <= (AdventureConfig.bossAnnounceRange * AdventureConfig.bossAnnounceRange)) {
                      ((ServerPlayer)p).f_8906_.m_9829_((Packet)new ClientboundSetActionBarTextPacket((Component)Component.m_237110_("info.apotheosis.boss_spawn", new Object[] { name, Integer.valueOf((int)boss.m_20185_()), Integer.valueOf((int)boss.m_20186_()) })));
                      TextColor color = name.m_7383_().m_131135_();
                      PacketDistro.sendTo(Apotheosis.CHANNEL, new BossSpawnMessage(boss.m_20183_(), (color == null) ? 16777215 : color.m_131265_()), player);
                    } 
                  });
            } 
            this.bossCooldowns.put(mob.m_9236_().m_46472_().m_135782_(), AdventureConfig.bossSpawnCooldown);
          } 
        } 
      } 
    } 
  }
  
  @Nullable
  private Component getName(Mob boss) {
    return boss.m_20199_().filter(e -> e.getPersistentData().m_128441_("apoth.boss")).findFirst().map(Entity::m_7770_).orElse(null);
  }
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void minibosses(MobSpawnEvent.FinalizeSpawn e) {
    Mob mob = e.getEntity();
    RandomSource rand = e.getLevel().m_213780_();
    if (!e.getLevel().m_5776_() && mob instanceof Mob) {
      Mob mob1 = mob;
      if (e.getResult() != Event.Result.DENY) {
        ServerLevelAccessor sLevel = e.getLevel();
        Player player = sLevel.m_45924_(e.getX(), e.getY(), e.getZ(), -1.0D, false);
        if (player == null)
          return; 
        ApothMiniboss item = (ApothMiniboss)MinibossRegistry.INSTANCE.getRandomItem(rand, player.m_36336_(), new Predicate[] { WeightedDynamicRegistry.IDimensional.matches((Level)sLevel.m_6018_()), GameStagesCompat.IStaged.matches(player), MinibossRegistry.IEntityMatch.matches((Entity)mob) });
        if (item != null && !item.isExcluded(mob1, sLevel, e.getSpawnType()) && sLevel.m_213780_().m_188501_() <= item.getChance()) {
          mob1.getPersistentData().m_128359_("apoth.miniboss", MinibossRegistry.INSTANCE.getKey((CodecProvider)item).toString());
          mob1.getPersistentData().m_128350_("apoth.miniboss.luck", player.m_36336_());
          if (!item.shouldFinalize())
            e.setCanceled(true); 
        } 
      } 
    } 
  }
  
  @SubscribeEvent(priority = EventPriority.LOWEST)
  public void delayedMinibosses(EntityJoinLevelEvent e) {
    if (!(e.getLevel()).f_46443_) {
      Entity entity = e.getEntity();
      if (entity instanceof Mob) {
        Mob mob = (Mob)entity;
        String key = mob.getPersistentData().m_128461_("apoth.miniboss");
        if (key != null) {
          ApothMiniboss item = (ApothMiniboss)MinibossRegistry.INSTANCE.getValue(new ResourceLocation(key));
          if (item != null)
            item.transformMiniboss((ServerLevelAccessor)e.getLevel(), mob, e.getLevel().m_213780_(), mob.getPersistentData().m_128457_("apoth.miniboss.luck")); 
        } 
      } 
    } 
  }
  
  @SubscribeEvent
  public void tick(TickEvent.LevelTickEvent e) {
    if (e.phase == TickEvent.Phase.END)
      this.bossCooldowns.computeIntIfPresent(e.level.m_46472_().m_135782_(), (key, value) -> Integer.valueOf(Math.max(0, value.intValue() - 1))); 
  }
  
  @SubscribeEvent
  public void load(ServerStartedEvent e) {
    e.getServer().m_129880_(Level.f_46428_).m_8895_().m_164861_(this::loadTimes, () -> new TimerPersistData(this), "apotheosis_boss_times");
  }
  
  private TimerPersistData loadTimes(CompoundTag tag) {
    this.bossCooldowns.clear();
    for (String s : tag.m_128431_()) {
      ResourceLocation id = new ResourceLocation(s);
      int val = tag.m_128451_(s);
      this.bossCooldowns.put(id, val);
    } 
    return new TimerPersistData(this);
  }
  
  private static boolean canSpawn(LevelAccessor world, Mob entity, double playerDist) {
    if (playerDist > (entity.m_6095_().m_20674_().m_21611_() * entity.m_6095_().m_20674_().m_21611_()) && entity.m_6785_(playerDist))
      return false; 
    return (entity.m_5545_(world, MobSpawnType.NATURAL) && entity.m_6914_((LevelReader)world));
  }
}
